
package de.ivu.elect.business.wahlvorschlagsperson.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;

@RequestScoped
@Named(WahlvorschlagsPersonConversationSelect.COMPONENT_NAME)
public class WahlvorschlagsPersonConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlvorschlagsPersonConversationSelect";

  @Inject
  protected transient WahlvorschlagsPersonExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlvorschlagsPersonConversationStore.class)
  protected transient WahlvorschlagsPersonConversationStore conversationStore;

  public WahlvorschlagsPersonConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public WahlvorschlagsPerson getEntity() {
    return getEntityInternal();
  }

  private WahlvorschlagsPerson getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(WahlvorschlagsPerson entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(WahlvorschlagsPerson entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.PersonendatenPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.PersonendatenPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected WahlvorschlagsPerson attach(WahlvorschlagsPerson entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected WahlvorschlagsPerson attach( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
